Codeforces Round #154 (Div. 2)

2023-12-10 04:33
文章标签 codeforces round div 154

本文主要是介绍Codeforces Round #154 (Div. 2),希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

A. Boys and Girls

水题啊,但是却是我最大的痛,由于没弄清题意,结果重测时没想到竟然WA了,最后导致我才2题悲剧地掉rating了大哭不想解释了...


B. Physics Practical

题目大意:给一个序列,要让这个序列的最小值x,最大值y,满足x*2 >= y. 问最少需要删除几个数

我的思路:

这题和上一场的C题的方法是一样的。

先把这个序列A排序,然后枚举“区间”的最右点right, 找这个区间满足arr【left】*2 <= A【right】的最左点。可以看出是满足单调性的,所以用二分可以找到。也可以通过维护一个指针p,使得A【p】*2 <=  A【right】。

然后这个区间肯定是满足条件的,所以把除了这个区间之外的数全部删掉。最后看删得最少的区间那个就是答案。

代码:

#include<iostream>
#include<algorithm>
#include<cstdio>
#include<cmath>
#define REP(i,n) for(int i=0; i<(n); ++i)
using namespace std;
typedef long long int64;
const int MAXN = 1000005;
int n, m;
int arr[MAXN];int main(){
#ifndef LOCALfreopen("input.txt","r", stdin);freopen("output.txt","w",stdout);
#endifwhile(~scanf("%d", &n)){REP(i, n)scanf("%d", &arr[i]);sort(arr, arr+n);if(arr[0] * 2 >= arr[n-1]){puts("0");}else{int p=0, ans=MAXN+10;for(int i=1; i<n; ++i){while(arr[p]*2 < arr[i]) ++p;int now = p + (n - 1)-i;if(now < ans) ans=now;}printf("%d\n", ans);}}return 0;
}


C. Text Editor

第一眼看过去,感觉挺吓人的。再仔细分析一下,其实是很水的。

从r1到r2, 它不一定是直接直直的移到那一行的,它可能是移动到i行,然后再移动到r2行。所以我们可以枚举“中转站”i, 然后算出r1-> i -> r2,共走了s1行。 走到r2行之后,就要走到c2列去了。这时,走了那么多行由于不同行的长度不一样,所以原先在r1列,现在可能已经不在r1了。所以要求出当前在第几列。 通过观察,其实可以发现就是r1 -> i -> r2这段路程中,长度最小的那行len, 然后min(r1, len)就是当前所在列了。


代码:

#include<iostream>
#include<algorithm>
#include<cstdio>
#include<cstring>
#include<cmath>
#define REP(i,n) for(int i=0; i<(n); ++i)
#define FOR(i,s,t) for(int i=(s); i<(t); ++i)
using namespace std;
typedef long long int64;const int MAXN = 1000005;
int n, m;
int arr[MAXN];int getMin(int r1, int r2, int c){int minx = c;if(r1 < r2){for(int i=r1+1; i<=r2; ++i){if(arr[i]+1 < minx)minx=arr[i]+1;}}else{for(int i=r1-1; i>=r2; --i){if(arr[i]+1 < minx)minx=arr[i]+1;}}return minx;
}int main(){
#ifndef LOCALfreopen("input.txt","r", stdin);freopen("output.txt","w",stdout);
#endifint r1, c1, r2, c2;while(~scanf("%d", &n)){FOR(i,1,n+1) scanf("%d", &arr[i]);scanf("%d%d%d%d",&r1,&c1,&r2,&c2);int ans=MAXN+100; for(int i=1; i<=n; ++i){int min1 = getMin(r1, i, c1);int min2 = getMin(i, r2, min1);int tmp = abs(r1-i) + abs(i-r2) + abs(c2-min2);if(tmp < ans) ans=tmp;}printf("%d\n", ans);}   return 0;
}


D. Table with Letters - 2


E. Printer



原创 http://blog.csdn.net/shuangde800   (转载请标明)

这篇关于Codeforces Round #154 (Div. 2)的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/476030

相关文章

Codeforces Round #240 (Div. 2) E分治算法探究1

Codeforces Round #240 (Div. 2) E  http://codeforces.com/contest/415/problem/E 2^n个数,每次操作将其分成2^q份,对于每一份内部的数进行翻转(逆序),每次操作完后输出操作后新序列的逆序对数。 图一:  划分子问题。 图二: 分而治之,=>  合并 。 图三: 回溯:

Codeforces Round #261 (Div. 2)小记

A  XX注意最后输出满足条件,我也不知道为什么写的这么长。 #define X first#define Y secondvector<pair<int , int> > a ;int can(pair<int , int> c){return -1000 <= c.X && c.X <= 1000&& -1000 <= c.Y && c.Y <= 1000 ;}int m

Codeforces Beta Round #47 C凸包 (最终写法)

题意慢慢看。 typedef long long LL ;int cmp(double x){if(fabs(x) < 1e-8) return 0 ;return x > 0 ? 1 : -1 ;}struct point{double x , y ;point(){}point(double _x , double _y):x(_x) , y(_y){}point op

Codeforces Round #113 (Div. 2) B 判断多边形是否在凸包内

题目点击打开链接 凸多边形A, 多边形B, 判断B是否严格在A内。  注意AB有重点 。  将A,B上的点合在一起求凸包,如果凸包上的点是B的某个点,则B肯定不在A内。 或者说B上的某点在凸包的边上则也说明B不严格在A里面。 这个处理有个巧妙的方法,只需在求凸包的时候, <=  改成< 也就是说凸包一条边上的所有点都重复点都记录在凸包里面了。 另外不能去重点。 int

Codeforces 482B 线段树

求是否存在这样的n个数; m次操作,每次操作就是三个数 l ,r,val          a[l] & a[l+1] &......&a[r] = val 就是区间l---r上的与的值为val 。 也就是意味着区间[L , R] 每个数要执行 | val 操作  最后判断  a[l] & a[l+1] &......&a[r] 是否= val import ja

CSS实现DIV三角形

本文内容收集来自网络 #triangle-up {width: 0;height: 0;border-left: 50px solid transparent;border-right: 50px solid transparent;border-bottom: 100px solid red;} #triangle-down {width: 0;height: 0;bor

创建一个大的DIV,里面的包含两个DIV是可以自由移动

创建一个大的DIV,里面的包含两个DIV是可以自由移动 <body>         <div style="position: relative; background:#DDF8CF;line-height: 50px"> <div style="text-align: center; width: 100%;padding-top: 0px;"><h3>定&nbsp;位&nbsp;

Codeforces Round 971 (Div. 4) (A~G1)

A、B题太简单,不做解释 C 对于 x y 两个方向,每一个方向至少需要 x / k 向上取整的步数,取最大值。 由于 x 方向先移动,假如 x 方向需要的步数多于 y 方向的步数,那么最后 y 方向的那一步就不需要了,答案减 1 代码 #include <iostream>#include <algorithm>#include <vector>#include <string>

CF#271 (Div. 2) D.(dp)

D. Flowers time limit per test 1.5 seconds memory limit per test 256 megabytes input standard input output standard output 题目链接: http://codeforces.com/contest/474/problem/D We s

CF #278 (Div. 2) B.(暴力枚举+推导公式+数学构造)

B. Candy Boxes time limit per test 1 second memory limit per test 256 megabytes input standard input output standard output 题目链接: http://codeforces.com/contest/488/problem/B There